#!/usr/bin/env node
"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.refreshScreen = exports.setData = exports.initialize = void 0;
const neo_blessed_1 = require("neo-blessed");
const table_1 = __importDefault(require("../ui/table"));
const popups_1 = require("./popups");
let mainScreen;
let table;
function initialize() {
    mainScreen = (0, neo_blessed_1.Screen)({
        smartCSR: true,
    });
    mainScreen.title = "neoss";
    mainScreen.key(["escape", "q", "C-c"], function () {
        return process.exit(0);
    });
    (0, popups_1.setDefaultScreen)(mainScreen);
    table = (0, table_1.default)({
        keys: true,
        interactive: true,
        tags: true,
        top: "0",
        left: "center",
        width: "100%",
        height: "shrink",
        border: {
            type: "line",
        },
        style: {
            fg: "white",
            border: {
                fg: "white",
            },
            focus: {
                bg: "blue",
            },
            header: {
                fg: "black",
                bg: "white",
            },
        },
    });
}
exports.initialize = initialize;
function setData(data) {
    mainScreen.append(table);
    table.setData({
        headers: ["Protocol", "State", "Rx", "Tx", "Local Address", "Local Port", "Peer Address", "Peer Port", "Users"],
        data: data,
    });
}
exports.setData = setData;
function refreshScreen() {
    table.setData(table.table);
}
exports.refreshScreen = refreshScreen;
