"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.whois = void 0;
const whoisJson = require("whois-json");
function whois(domain) {
    return __awaiter(this, void 0, void 0, function* () {
        let domainName = domain.split(".");
        if (domainName.some(isNaN)) {
            domainName = domainName.slice(-2).join(".");
        }
        else {
            domainName = domain;
        }
        let data = yield whoisJson(domainName);
        data = toString(data);
        if (data.includes("no entries")) {
            return "No entries found.";
        }
        return data;
    });
}
exports.whois = whois;
function toString(data) {
    let text = "";
    for (const key in data) {
        text += `${key}: ${data[key]}\n`;
    }
    return text;
}
